package BPpath.hanzi.flashcards;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.CheckBox;
import android.widget.Toast;
import BPpath.hanzi.R;

 
/*
 * SideSelection.java is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * author: R. Earle Harris (evsiz@this-voice.org) copyrighted 2014
 *
 */

public class SideSelection extends Activity {

	public String sides = "xxxx";
	public String headers;
	public CheckBox check_A;
	public CheckBox check_B;
	public CheckBox check_C;
	public CheckBox check_D;
	public CheckBox check_0;
	public CheckBox check_1;
	public CheckBox check_2;
	public CheckBox check_3;
	public int fields;
	public String[] choices;
	public int mode;
	public static final int STUDY_MODE = 0;
	public static final int TEST_MODE = 1;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		Intent origin = this.getIntent();
		headers = origin.getStringExtra("HEADERS");
		mode = origin.getIntExtra("MODE", -1);
		setContentView(R.layout.activity_side_selection);
		findViews();

		while (headers.contains("\t\t")){
			headers = headers.replace("\t\t", "\t");
		}
		final String[] CHOICES = headers.split("\t");
		choices = CHOICES;
		int length = CHOICES.length;
		fields = length;
		if ((length < 2) || (length > 4)){
			Toast.makeText(this, "There must be only 2 to 4 categories",
					Toast.LENGTH_SHORT).show();
			finish();
		} else {

			check_A.setEnabled(true);
			check_A.setText(CHOICES[0]);
			check_B.setEnabled(true);
			check_B.setText(CHOICES[1]);
			if (mode == STUDY_MODE){
				check_0.setEnabled(true);
				check_1.setEnabled(true);
			}
			check_0.setText(choices[0]);
			check_1.setText(choices[1]);
			if (length == 3){
				check_C.setEnabled(true);
				check_C.setText(CHOICES[2]);
				if (mode == STUDY_MODE){
					check_2.setEnabled(true);
				}
				check_2.setText(choices[2]);
			}
			if (length == 4){
				check_C.setEnabled(true);
				check_C.setText(CHOICES[2]);
				check_D.setEnabled(true);
				check_D.setText(CHOICES[3]);
				if (mode == STUDY_MODE){
					check_2.setEnabled(true);
					check_3.setEnabled(true);
				}
				check_2.setText(choices[2]);
				check_3.setText(choices[3]);
			}

		}

	}


	private void findViews() {
		check_A = (CheckBox) findViewById(R.id.check_A);
		check_B = (CheckBox) findViewById(R.id.check_B);
		check_C = (CheckBox) findViewById(R.id.check_C);
		check_D = (CheckBox) findViewById(R.id.check_D);
		check_0 = (CheckBox) findViewById(R.id.check_0);
		check_1 = (CheckBox) findViewById(R.id.check_1);
		check_2 = (CheckBox) findViewById(R.id.check_2);
		check_3 = (CheckBox) findViewById(R.id.check_3);
	}


	public void clickA(View view) {
		if (mode == TEST_MODE){
			check_B.setChecked(false);
			check_C.setChecked(false);
			check_D.setChecked(false);
			setAnswer(0);
		} else {
			char val;
			if (check_A.isChecked()) {
				val = 'a';
				check_0.setChecked(false);
			} else {
				val = 'x';
			}
			setSides(0, val);
		}
	}


	public void clickB(View view) {
		if (mode == TEST_MODE){
			check_A.setChecked(false);
			check_C.setChecked(false);
			check_D.setChecked(false);
			setAnswer(1);
		} else {
			char val;
			if (check_B.isChecked()) {
				val = 'a';
				check_1.setChecked(false);
			} else {
				val = 'x';
			}
			setSides(1, val);
		}
	}


	public void clickC(View view) {
		if (mode == TEST_MODE){
			check_A.setChecked(false);
			check_B.setChecked(false);
			check_D.setChecked(false);
			setAnswer(2);
		} else {
			char val;
			if (check_C.isChecked()) {
				val = 'a';
				check_2.setChecked(false);
			} else {
				val = 'x';
			}
			setSides(2, val);
		}
	}


	public void clickD(View view) {
		if (mode == TEST_MODE){
			check_A.setChecked(false);
			check_B.setChecked(false);
			check_C.setChecked(false);
			setAnswer(3);
		} else {
			char val;
			if (check_D.isChecked()) {
				val = 'a';
				check_3.setChecked(false);
			} else {
				val = 'x';
			}
			setSides(3, val);
		}
	}

	//TODO redo from list to checkbox
	public void setAnswer(int answer) {
		sides = "xxxx";
		findViews();
		check_0.setChecked(false);
		check_1.setChecked(false);
		check_2.setChecked(false);
		check_3.setChecked(false);
		
		char[] sidesChars = sides.toCharArray();
		sidesChars[answer] = 'a';
		sides = String.valueOf(sidesChars);
		switch (answer) {
		case 0:
			check_0.setEnabled(false);
			check_1.setEnabled(true);
			if (fields > 2) {
				check_2.setEnabled(true);
			}
			if (fields > 3) {
				check_3.setEnabled(true);
			}
			break;
		case 1:
			check_0.setEnabled(true);
			check_1.setEnabled(false);
			if (fields > 2) {
				check_2.setEnabled(true);
			}
			if (fields > 3) {
				check_3.setEnabled(true);
			}
			break;
		case 2:
			check_0.setEnabled(true);
			check_1.setEnabled(true);
			check_2.setEnabled(false);
			if (fields > 3) {
				check_3.setEnabled(true);
			}
			break;
		case 3:
			check_0.setEnabled(true);
			check_1.setEnabled(true);
			check_2.setEnabled(true);
			check_3.setEnabled(false);
			break;
		}
		return;
	}

	private void setSides(int loc, char val) {
		char[] sidesChars = sides.toCharArray();
		sidesChars[loc] = val;
		sides = String.valueOf(sidesChars);
		//		Toast.makeText(this, sides, Toast.LENGTH_SHORT).show();
	}

	public void click0(View view) {
		char val;
		if (check_0.isChecked()) {
			val = 'q';
			check_A.setChecked(false);
		} else {
			val = 'x';
		}
		setSides(0, val);
	}

	public void click1(View view) {
		char val;
		if (check_1.isChecked()) {
			val = 'q';
			check_B.setChecked(false);
		} else {
			val = 'x';
		}
		setSides(1, val);
	}

	public void click2(View view) {
		char val;
		if (check_2.isChecked()) {
			val = 'q';
			check_C.setChecked(false);
		} else {
			val = 'x';
		}
		setSides(2, val);
	}

	public void click3(View view) {
		char val;
		if (check_3.isChecked()) {
			val = 'q';
			check_D.setChecked(false);
		} else {
			val = 'x';
		}
		setSides(3, val);
	}

	public void sidesDone(View view) {
		if (sides == null){ return; }
		if (sides.indexOf('q') == -1) {
			Toast.makeText(this, "Card has no question element",
					Toast.LENGTH_SHORT).show();
		} else if (sides.indexOf('a') == -1) {
			Toast.makeText(this, "Card has no answer element",
					Toast.LENGTH_SHORT).show();
		} else {
			Intent intent = new Intent();
			intent.putExtra("SIDES", sides);
			setResult(RESULT_OK, intent);
			finish();
		}
	}

	@Override
	public void onBackPressed() {
		Intent intent = new Intent();
		setResult(RESULT_CANCELED, intent);
		finish();
	}

}
