package BPpath.hanzi.flashcards;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.res.AssetManager;
import android.os.Bundle;
import android.os.Handler;
import android.view.Gravity;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnTouchListener;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;
import BPpath.hanzi.PRAFileHandler;
import BPpath.hanzi.R;

 
/*
 * Test.java is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * author: R. Earle Harris (evsiz@this-voice.org) copyrighted 2014
 *
 */

public class Test extends Activity implements OnTouchListener {

	public WebView wv;
	public TextView title;
	public Button wrongBtn;
	public Button undoBtn;
	public Button rightBtn;
	public WebViewClient client;
	public AssetManager am;

	public PRAFileHandler fhandler = new PRAFileHandler(this);
	public Iterator<String> iterator;

	public String[] currentCard = { "", "", "", "", "" };
	public String[] titles;
	public String[] sizes;

	public List<String> deck;
	public List<String> correctCards = new ArrayList<String>();
	
	public String card2remove = "";
	public String current_fname;
	public String deck_fname;
	public String ext;
	public String field_0;
	public String field_1;
	public String field_2;
	public String field_3;
	public String headers;
	public String lastTest;
	public String line0;
	public String line1;
	public String onError = "";
	public String pendingUndo = "";
	public String record;
	public String sides;
	public String test;
	public String test_name;
	public String undo = "";
	
	public int score;
	public int which = 0;
	public int length = 0;
	public int wrongCount = 0;
	public int max;
	public int title_index;

	public boolean[] answer = { false, false, false, false };
	public boolean[] query = { false, false, false, false };
	public boolean lastWasUndo = false;
	public boolean lastRight = false;
	public boolean isAnswer = false;
	public boolean ruzhe = false;
	public boolean ziji = false;

	public String head;
	public String headAll = "<html><head><meta charset=\"utf-8\"></head>"
			+ "<body bgcolor=000 link=fff alink=fff vlink=fff >"
			+ "<center>" + "<style type=text/css>"
			+ "div.field_0{color: f90; font-size: $SZ0px; margin-top: 48px;}"
			+ "div.field_1{color: 3c3; font-size: $SZ1px;}"
			+ "div.field_2{color: 3c3; font-size: $SZ2px;}"
			+ "div.field_3{color: 3c3; font-size: $SZ3px;}</style>";
	public String headZiji = "<html><head><meta charset=\"utf-8\"></head>"
			+ "<body bgcolor=000 link=fff alink=fff vlink=fff ><h1>&nbsp;</h1>"
			+ "<center>" + "<style type=text/css>"
			+ "div.field_0{color: F99; font-size: $SZ0px; margin-top: 32px;}"
			+ "div.field_1{color: F99; font-size: $SZ1px;}"
			+ "div.field_2{color: F99; font-size: $SZ2px;}"
			+ "div.field_3{color: F99; font-size: $SZ3px;}</style>";
	public String headRuzhe = "<html><head><meta charset=\"utf-8\"></head>"
			+ "<body bgcolor=#ffffeb link=fff alink=fff vlink=fff >"
			+ "<center>" + "<style type=text/css>"
			+ "div.field_0{color: 744; font-size: $SZ0px; margin-top: 32px;}"
			+ "div.field_1{color: 000; font-size: $SZ1px;}"
			+ "div.field_2{color: 900; font-size: $SZ2px;}"
			+ "div.field_3{color: 000; font-size: $SZ3px;}</style>";
	public String page = "<div class=\"field_0\">$0</div>"
			+ "<div class=\"field_1\">$1</div>"
			+ "<div class=\"field_2\">$2</div>"
			+ "<div class=\"field_3\">$3</div>";
	public String close = "<h2>&nbsp;</h2></body></html>";

	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		String appname = getResources().getString(R.string.app_name);
		if (appname.startsWith("Ruzhe")){
			ruzhe = true;
			head = headRuzhe;
		} else if (appname.startsWith("Ziji")){
			ruzhe = true;
			ziji = true;
			head = headZiji;
		}  else {
			head = headAll;
		}

		Intent origin = this.getIntent();
		headers = origin.getStringExtra("HEADERS");
		sides = origin.getStringExtra("SIDES");
		setSides();//ext set here

		line0 = origin.getStringExtra("HEADERS");
		while (line0.contains("\t\t")){
			line0 = line0.replace("\t\t", "\t");
		}
		titles = line0.split("\t");
		test = titles[title_index];

		lastTest = "last_test_"+test+".txt";
		fhandler.remove(lastTest);
		fhandler.remove("last_hdrs_"+test+".txt");
		fhandler.writeUniqLineByTokens("last_hdrs_"+test+".txt", headers, "\t");

		line1 = origin.getStringExtra("SIZES");
		while (line1.contains("\t\t")){
			line1 = line1.replace("\t\t", "\t");
		}
		fhandler.writeUniqLineByTokens("last_hdrs_"+test+".txt", line1, "\t");
		sizes = line1.split("\t");
		setSizes();

		deck_fname = origin.getStringExtra("DECK");
		List<String> orig;
		List<String> decktmp;

		if ((ruzhe) && (!ziji)){
			String set = origin.getStringExtra("SET");
			test_name = deck_fname + "_" + set;
			current_fname = test_name + ext;
			orig = Arrays.asList(origin.getStringArrayExtra("CARDS"));
			decktmp = fhandler.getFileAsList(current_fname);
		} else {
			String[] tokens = deck_fname.split("/");
			String fname = tokens[tokens.length -1];
			fname = fname.replace(".txt", "");
			current_fname = fname + ext;
			test_name = fname.replace("_", " ");
			test_name = test_name.substring(0,1).toUpperCase() + fname.substring(1);
			decktmp = fhandler.getFileAsList(current_fname);
			if (appname.matches("Ziji Zidian")){
				orig = fhandler.getExtFileAsList("", deck_fname);
			} else {
				orig = fhandler.getAssetAsList(deck_fname);
			}
		}
		
		if (appname.matches("BoilerPlate")){
				orig.remove(0);
				orig.remove(0);
		}
		if (decktmp.size() == 0) {
			deck =  orig;
		} else {
			deck = decktmp;
		}

		max = deck.size();
		iterator = deck.iterator();
		setContentView(R.layout.activity_test);
		findViews();
		wrongBtn.setBackgroundResource(R.drawable.icon_wrong);
		undoBtn.setBackgroundResource(R.drawable.icon_undo);
		rightBtn.setBackgroundResource(R.drawable.icon_check_on);
		setProgress();
		wv.setOnTouchListener(this);
		wv.setScrollBarStyle(View.SCROLLBARS_INSIDE_OVERLAY);

		client = new WebViewClient() {
			@Override
			public boolean shouldOverrideUrlLoading(WebView view, String url) {
				wv.loadUrl(url);
				return true;
			}
		};
		wv.setWebViewClient(client);
		String card = iterator.next();
		pendingUndo = card;
		showQuery(card);
	}
	
	public void setSizes(){
		head = head.replace("$SZ0", sizes[0]);
		head = head.replace("$SZ1", sizes[1]);
		if (sizes.length >= 3){
			head = head.replace("$SZ2", sizes[2]);
		}
		if (sizes.length == 4){
			head = head.replace("$SZ3", sizes[3]);
		}
	}

	private void findViews() {
		wv = (WebView) findViewById(R.id.webview3);
		wrongBtn = (Button) findViewById(R.id.wrong);
		undoBtn = (Button) findViewById(R.id.undo);
		rightBtn = (Button) findViewById(R.id.right);
		title = (TextView) findViewById(R.id.title);
	}


	public void setProgress() {
		test_name = test_name.replace("_", " ");
		record = test_name + " " + test + ": "
			+ Integer.toString(score) + "/" + Integer.toString(max) 
			+ " (x: " + Integer.toString(wrongCount) + ")";
		title.setText(record);
	}

	public void setSides() {
		for (int i = 0; i < 4; i++) {
			// put the prompts on query
			if (sides.charAt(i) == 'q') {
				query[i] = true;
				// but show them on answer too
				answer[i] = true;
			}
			// just answer on answer side
			if (sides.charAt(i) == 'a') {
				answer[i] = true;
				ext = "." + Integer.toString(i);
				title_index = i;
			}
		}
	}


	public void removeCard(){
		if (!card2remove.matches("")) {
			correctCards.add(card2remove);
			card2remove = "";
		}
	}
	
	public void showQuery(String line) {
		isAnswer = false;
		while (line.contains("\t\t")){
			line = line.replace("\t\t", "\t");
		}
		String[] tokens = line.split("\t");
		try {
			field_0 = tokens[0];
			field_1 = tokens[1];
			if ((ruzhe) && (field_1.trim().matches("-"))){
				field_1 = field_0;
			}
			field_2 = tokens[2];
			field_3 = tokens[3];
			if (ruzhe){
				field_3 = field_3.replace("_", " ");
			}
		} catch (Exception e) {
			// empty
		}
		String current = head;
		current = current + page;
		if (query[0]) {
			current = current.replace("$0", field_0);
		} else {
			current = current.replace("$0", "");
		}
		if (query[1]) {
			current = current.replace("$1", "<br>"+field_1);
		} else {
			current = current.replace("$1", "");
		}
		if (query[2]) {
			current = current.replace("$2", "<br>"+field_2);
		} else {
			current = current.replace("$2", "");
		}
		if (query[3]) {
			current = current.replace("$3", "<br>"+field_3);
		} else {
			current = current.replace("$3", "");
		}
		current = current + close;
		wv.loadData(current, "text/html;charset=utf-8", "utf-8");
		wv.clearHistory();
	}

	public void showAnswer() {
		isAnswer = true;
		String current = head;
		current = current + page;
		if (answer[0]) {
			current = current.replace("$0", field_0);
		} else {
			current = current.replace("$0", "");
		}
		if (answer[1]) {
			current = current.replace("$1", "<br>"+field_1);
		} else {
			current = current.replace("$1", "");
		}
		if (answer[2]) {
			current = current.replace("$2", "<br>"+field_2);
		} else {
			current = current.replace("$2", "");
		}
		if (answer[3]) {
			current = current.replace("$3", "<br>"+field_3);
		} else {
			current = current.replace("$3", "");
		}
		current = current + close;
		onError = current;
		wv.loadData(current, "text/html;charset=utf-8", "utf-8");
		wv.clearHistory();
	}

	public void listComplete() {
		String end;
		if (wrongCount > 0){
			end = " End of List";
			removeCard();
			List<String> remainder = new ArrayList<String>();
			for (String s : deck){
				if (!correctCards.contains(s)){
					remainder.add(s);
				}
			}
			fhandler.writeListToFile(remainder, current_fname);
		} else {
			end = " Completed";
			fhandler.remove(current_fname);
		}
		String msg = end + ": "	+ Integer.toString(score) + "/" + Integer.toString(max);
		AlertDialog.Builder builder = new AlertDialog.Builder(this);
		builder.setMessage(msg)
		       .setTitle(test_name + " - " + test);
		builder.setPositiveButton("OK", new DialogInterface.OnClickListener() {
	           public void onClick(DialogInterface dialog, int id) {
				   List<String> top = Arrays.asList(record); 
				   fhandler.writeToTopOfFile(top, "Memo.txt");
	               finish();
	           }
	       });
		AlertDialog dialog = builder.create();
		dialog.show();
	}

	public void cardWrong(View view) {
		if (!isAnswer) {
			return;
		}
		removeCard();
		String card;
		wrongCount++;
		setProgress();
		lastRight = false;
		while (pendingUndo.contains("\t\t")){
			pendingUndo = pendingUndo.replace("\t\t", "\t");
		}
		if (lastWasUndo){
			fhandler.writeUniqLineByTokens(lastTest, undo, "\t");
			card = pendingUndo;
			lastWasUndo = false;
			showQuery(card);
		} else if (iterator.hasNext()) {
			fhandler.writeUniqLineByTokens(lastTest, pendingUndo, "\t");
			card = iterator.next();
			undo = pendingUndo;
			pendingUndo = card;
			showQuery(card);
		} else {
			fhandler.writeUniqLineByTokens(lastTest, pendingUndo, "\t");
			listComplete();
		}
	}

	public void cardUndo(View view) {
		String card;
		if (lastWasUndo || undo.matches("") ) {
			return;
		}
		lastWasUndo = true;
		card2remove = "";
		if (lastRight) {
			score--;
		} else {
			wrongCount--;
		}
		setProgress();
		card = undo;
		showQuery(card);
	}

	public void cardRight(View view) {
		if (!isAnswer) {
			return;
		}
		card2remove = pendingUndo;
		removeCard();
		String card;
		score++;
		setProgress();
		lastRight = true;
		if (lastWasUndo){
			String token0 = undo.split("\t")[0];
			fhandler.removeLineByFullToken0(lastTest, token0, "\t");
			card = pendingUndo;
			lastWasUndo = false;
			showQuery(card);
		} else if (iterator.hasNext()) {
			card = iterator.next();
			undo = pendingUndo;
			pendingUndo = card;
			showQuery(card);
		} else {
			listComplete();
		}
	}

	/**
	 * TODO why do we need up and down both calling the method? Are we actually
	 * doing a click here?
	 */
	@Override
	public boolean onTouch(View v, MotionEvent event) {
		if (v.getId() == R.id.webview3) {
			switch (event.getAction()) {
			case MotionEvent.ACTION_DOWN:
				showAnswer();
				return false;
			case MotionEvent.ACTION_UP:
				showAnswer();
				return false;
			default:
				return false;
			}
		}
		return false;
	}

	private boolean doubleBackPressedOnce = false;

	@Override
	public void onBackPressed() {
		if (doubleBackPressedOnce) {
			removeCard();
			List<String> remainder = new ArrayList<String>();
			for (String s : deck){
				if (!correctCards.contains(s)){
					remainder.add(s);
				}
			}
			fhandler.writeListToFile(remainder, current_fname);
				List<String> top = Arrays.asList(record); 
				fhandler.writeToTopOfFile(top, "Memo.txt");
				super.onBackPressed();
				return;
		}
		doubleBackPressedOnce = true;
		Toast.makeText(this, R.string.exit2main, Toast.LENGTH_SHORT).show();
		new Handler().postDelayed(new Runnable() {

				@Override
					public void run() {
					doubleBackPressedOnce = false;
				}
			}, 2000);
	}


    // length gets Toast.LENGTH_LONG|SHORT
	public void toaster(String text, int length) {
		Toast t = Toast.makeText(this, text, length);
		t.setGravity(Gravity.CENTER, 0, 0);
		t.show();
	}

}
